library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity disp is
    Port ( clk,rst      : in std_logic;
           en           : out std_logic_vector(3 downto 0);
           seg          : out std_logic_vector(6 downto 0);
           Rel1_in 		: in std_logic;
           Rel2_in 		: in std_logic;
           Rel1,Rel2 	: out std_logic;
           LED 			: out std_logic_vector(15 downto 0)
           
           );
end disp;

architecture Behavioral of disp is
COMPONENT seg_7
	PORT(
		bcd : IN std_logic_vector(3 downto 0);          
		seg : OUT std_logic_vector(6 downto 0)
		);
	END COMPONENT;
signal bcd_clk	: std_logic;
signal led_clk	: std_logic;
signal div 		: std_logic_vector(22 downto 0);
signal bcd_s	: std_logic_vector( 3 downto 0);
signal led_s    : std_logic_vector(15 downto 0);
signal dir      : std_logic;
signal up,dwn   : std_logic; 

begin
	u1: seg_7 PORT MAP(
		bcd => bcd_s,
		seg => seg
	);
 
bcd_clk  <= div(22);
LED_clk  <= div(19);

en		<= "1111";
LED     <= led_s;
Rel1    <= Rel1_in;
Rel2    <= Rel2_in;

    process(clk,rst)
    begin
    	if rst='1' then 
    		div	<= (others=>'0');
    	 elsif clk'event and clk='1' then
        	div <= div +1;
        end if ;
    end process;

    process(led_clk,rst)
    begin
        if rst='1' then
            led_s   <= (0=>'1', others=>'0');
        elsif led_clk'event and led_clk='1' then
	 	     if dir='1' then
			     led_s	<= led_s(14 downto 0) & led_s(15);	
		     else
			     led_s	<= led_s(0) & led_s(15 downto 1);
    		 end if;
        end if;
    end process;

up		<= led_s(15);
dwn		<= led_s(0);



-- Changing the direction of RUN
	process(up,dwn,rst)
	begin
		if rst='1' then
			dir	<= '0';
		elsif up='1' then
			dir	<= '0';
		elsif dwn='1' then
			dir	<= '1';
		end if;
	end process;

	process(bcd_clk,rst)
	begin
		if rst='1' then 
			bcd_s	<= (others=>'0');
		 elsif bcd_clk'event and bcd_clk='1' then
			 	bcd_s	 	<= bcd_s +1;
		  end if ;
		end process;

end Behavioral;


