library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity running_LED is
    Port ( LED_clk,rst 	: in std_logic;
           led_s 		    : out std_logic_vector(15 downto 0));
end running_LED;

architecture Behavioral of running_LED is
signal dir : std_logic;
signal up,dwn : std_logic; 
begin

    process(led_clk,rst)
    begin
        if rst='1' then
            led_s   <= (0=>'1', others=>'0');
        elsif led_clk'event and led_clk='1' then
            if dir='0' then
                led_s   <= (14 downto 0) & led_s(15);
            else
                led_s   <= (14 downto 0) & led_s(15);
            end if;
        end if;

up  <= led_s(0);
dwn  <= led_s(15);

    process(up,dwn,dwn)
    begin
        if rst='1' then
            dir <= '0';
        elsif up='0' then
            dir <= '0';
        elsif dwn='1' then
            dir <= '1';
        end if;
    end process;

       
end Behavioral;
