--------------------------------------------------------------------------------
-- Title				:	Feed through for LCD
-- Project			:	Sample code
-- File				:	lcd_feed.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	Feed through program for LCD Display
--							LCD controller is in Atmel controller, 
--							FPGA takes data from uC and displays on LCD
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity LCD_Feed is
    Port ( rs_in : in std_logic;
           en_in : in std_logic;
           p0_in : in std_logic_vector(7 downto 0);
           data : out std_logic_vector(7 downto 0);
		   	led : out std_logic_vector(7 downto 0);
           rs : out std_logic;
           en : out std_logic);
end LCD_Feed;

architecture Behavioral of LCD_Feed is

begin
rs	<= rs_in;
en	<= en_in;

data	<= p0_in;
led	<= p0_in;

end Behavioral;
