/* 	This Program multiplies 2 four bit data 
	first operand from upper PORT 0  
	second operand from lower PORT 0
	8-bit result on PORT 2, the result is encoded in 7-segment
	Also the result is sent serially on the serial PORT
	The display enable is controlled from PORT 1
*	This program runs with FPGA only.
	
*	This code is written for MATrix
*/

#include <intrins.h>
#include <reg52.h>

#define TIMER_RELOAD (-921)

typedef unsigned int UINT;
typedef unsigned char UCHAR;
typedef unsigned long ULONG;

sbit SEL0 = P1^4;  
sbit SEL1 = P1^5;  
sbit SEL2 = P1^6;  
sbit SEL3 = P1^7;  

//abcd efg
//1111 1100 0xfc 0
//0110 0000 0x60 1
//1101 1010 0xda 2
//1111 0010 0xf2 3
//0110 0110 0x66 4
//1011 0110 0xb6 5
//1011 1110 0xbe 6 
//1110 0000 0xe0 7
//1111 1110 0xfe 8
//1111 0110 0xf6 9

const UCHAR disp_buf[10] = {0xfc, 0x60, 0xda, 0xf2, 0x66, 0xb6, 0xbe, 0xe0, 0xfe, 0xf6};

UINT count;
bit secflag;
UCHAR digit, mult;
UINT digbuf[4];

void serial (void)
interrupt 4 using 2
{
	if(RI)
		RI = 0;
}

void timer0 (void) 
interrupt 1 using 1
{

	TL0 = TIMER_RELOAD;	
	TH0 = TIMER_RELOAD >> 8;

	count ++;
	switch(digit)
	{
		case 0 :
			SEL0 = 1; SEL1 = 0; SEL2 = 0; SEL3 = 0;
		break;
			
		case 1 :
			SEL0 = 0; SEL1 = 1; SEL2 = 0; SEL3 = 0;
		break;
			
		case 2 :
			SEL0 = 0; SEL1 = 0; SEL2 = 1; SEL3 = 0;
		break;
		
		case 3 :
			SEL0 = 0; SEL1 = 0; SEL2 = 0; SEL3 = 1;
		break;

		default :
			SEL2 = 0; SEL1 = 0; SEL0 = 0;SEL3 = 0;
			digit = 0;
		break;
	}
	P2 = digbuf[digit] >> 1;
	digit++;
	if(digit > 3)
		digit = 0;
}

void init_hw(void)
{
	TMOD = 0x21;
	IE = 0x92; //1001 0010
	SCON = 0x50; //0101 0000
	TL0 = TIMER_RELOAD;
	TH0 = TIMER_RELOAD >> 8;
	TH1 = TL1 = 0xFA;
	TR0 = 1;
	TR1 = 1;
}

void dispnum(UCHAR no)
{
	UCHAR i;
	for(i = 3; i != 0; i--)
	{
		digbuf[i-1] = disp_buf[no %10];
		no /= 10;
	}
}

void main(void)
{
	UCHAR first , second, oldno;
	UINT i;
	init_hw();	
	oldno = 0;
	while(1)
	{
		first =((P0 & 0xf0) >> 4);
		second = ((P0 & 0x0f));
		mult = first * second;
		dispnum(mult);
		if(oldno != mult)
		{
			SBUF = mult;
			TI = 0;
			for(i = 0; i < 500; i++);
			oldno = mult;
		}
	}
}
